% 
%   MLCV Winter 2015
%   Homework Assignment 03 - Hidden Markov Models
%
%   Exercise 1d) Viterbi algorithm
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [ tempProb, Path ] = viterbi_fun( observed, P_start, P_trans, P_sense, ...
                                        stateSpace, observationSpace )
%VITERBI_FUN Summary of this function goes here
%   observed            - a vector (sequence) of T observations {z_t}
%   stateSpace          - a cell array of K possible states {x_i}
%   observationSpace    - a cell array of Q possible observations {z_i}
%   P_start             - Kx1 vector, the initial probability of each state p(x_{t=0})
%   P_trans             - KxK matrix, the state transition matrix p(x_t|x_{t-1})
%   P_sense             - QxK matrix, the observation model p(z_i|x_i)


% Initialize
delta = P_start' .* P_sense(observed(1), :);
Path = arrayfun(@(x) {x}, stateSpace);


% Find (recursively) the most probable path
for t=2:length(observed)
    deltaOld = delta;
    PathOld  = Path;
    
    % that can lead to each state
    for curState=1:length(stateSpace)
        fprintf('Current state: %s\n deltas:\n', stateSpace{curState});
        tempProb = deltaOld .* P_trans(:, curState)'

        
        [maxProb, maxPrevState] = max(tempProb);
        maxPrevStates = find(tempProb == maxProb);
        fprintf('Max prob: %f \n', maxProb);
        fprintf('Most likely prev states: ');
        for i=1:length(maxPrevStates)
            fprintf('%s ', stateSpace{maxPrevStates(i)});
        end    
        
        delta(curState) = P_sense(observed(t),curState) * maxProb;
        Path{curState} = [PathOld{maxPrevState} stateSpace{curState}];
        
    end
    
end

% Return the most likely sequence and its probability
[tempProb, state] = max( delta );
Path = Path{state};

    
    
    
